/*$Id: d_cap.h,v 15.11 1999/10/14 07:46:49 al Exp $ -*- C++ -*-
 $ Capacitance (c) component
 */
#ifndef D_CAP_H
#define D_CAP_H
#include "e_storag.h"
/*--------------------------------------------------------------------------*/
class DEV_CAPACITANCE : public STORAGE {
private:
  explicit DEV_CAPACITANCE(const DEV_CAPACITANCE& p) :STORAGE(p) {}
public:
  explicit DEV_CAPACITANCE()	:STORAGE() {}
private: // override virtual
  const char* dev_type()const	{return "capacitor";}
  CARD*	   clone()const		{return new DEV_CAPACITANCE(*this);}
  //void   parse(CS&);		//ELEMENT
  //void   print(OMSTREAM,int)const; //ELEMENT
  //void   expand();		//CARD/nothing
  //void   precalc()		//STORAGE

  void     dc_begin()		{begin_core();}
  void     tr_begin()		{begin_core();}
  void     tr_restore()		{begin_core();}
  //void   dc_advance();	//STORAGE
  //void   tr_advance();	//STORAGE
  //bool   tr_needs_eval();	//STORAGE
  //void   tr_queue_eval();	//STORAGE
  bool	   do_tr();
  //void   tr_load();		//ONEPORT
  double   tr_review();
  //void   tr_accept();		//CARD/nothing
  //void   tr_unload();		//ONEPORT
  //double tr_involts()const;	//ONEPORT

  void	    ac_begin()		{ev = y0.f1;}
  void	    do_ac();
  //COMPLEX ac_involts()const;	//ONEPORT
private:
  void	   integrate();
};
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
#endif
