/*$Id: d_ccvs.h,v 15.11 1999/10/14 07:46:49 al Exp $ -*- C++ -*-
 * current controlled voltage source
 */
#ifndef D_CCVS_H
#define D_CCVS_H
#include "e_ccsrc.h"
/*--------------------------------------------------------------------------*/
class DEV_CCVS : public CCSRC_BASE {
private:
  explicit DEV_CCVS(const DEV_CCVS& p) :CCSRC_BASE(p) {untested();}
public:
  explicit DEV_CCVS()		:CCSRC_BASE() {}
private: // override virtual
  const char* dev_type()const	{return "ccvs";}
  CARD*	   clone()const		{untested(); return new DEV_CCVS(*this);}
  //void   parse(CS&);		//ELEMENT
  //void   print(OMSTREAM,int)const; //CCSRC_BASE
  //void   expand();		//CCSRC_BASE
  void	   precalc();

  void	   dc_begin();
  void	   tr_begin()		{dc_begin();}
  void	   tr_restore()		{dc_begin();}
  //void   dc_advance();	//CARD/nothing
  //void   tr_advance();	//CARD/nothing
  //bool   tr_needs_eval();	//CCSRC_BASE
  //void   tr_queue_eval();	//CCSRC_BASE
  bool	   do_tr();
  void	   tr_load()		{tr_load_loss(); tr_load_active();}
  //double tr_review();		//CARD/nothing
  //void   tr_accept();		//CARD/nothing
  //void   tr_unload();		//CCSRC_BASE
  //double tr_involts()const;	//CCSRC_BASE

  void	    ac_begin()		{loss = 1./OPT::shortckt; ev = y0.f1;}
  void	    do_ac();
  //COMPLEX ac_involts()const;	//CCSRC_BASE
};
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
#endif
